// Testprogramm fuer stdin, stdout, stderr
//
// Systemsoftware
// Hans-Georg Esser, 2021-10-23

#include <stdlib.h>
#include <unistd.h>
#include <readline/readline.h>

int main() {
	//  /dev/tty ist die aktuelle Konsole (ignoriert ">", "2>")
	FILE *tty = fopen ("/dev/tty", "w+");

	fprintf (tty,    "[tty] Testprogramm.\n");

	// Lies aus stdin (ggf. umgeleitet: "<")
	char *eingabe = readline (": ");

	// Schreibe auf tty, stdout (ggf. ">") und stderr (ggf. "2>")
	fprintf (tty,    "[tty] 1 Zeile aus stdin: %s\n", eingabe);
	fprintf (stdout, "[stdout] 1 Zeile nach stdout: %s\n", eingabe);
	fprintf (stderr, "[stderr] 1 Zeile nach stderr: %s\n", eingabe);

	// Programm beenden durch Aufruf von ls -l /proc/self/fd
	// Ausgabe von ls landet auch in stdout (ggf. ">")
	execlp ("ls", "ls", "-l", "/proc/self/fd/", (char*) 0);
}

